## pytorch-audio 0.7.2

=== requirements.txt ===
torch>=1.4.0

# Required for Windows because it's the only available backend
SoundFile; sys_platform == 'win32'

# Optional for torchaudio.kaldi_io
numpy
kaldi_io

# Required for tests only:

# Style-checking for PEP8
flake8

# Used for comparison of outputs in tests
librosa>=0.4.3
scipy

# Unit tests with pytest
pytest
