=== debian/changelog ===
pytorch-audio (0.7.2-1ubuntu2) jammy; urgency=medium

  * Drop X-Python3-Version: 3.9 from debian/control

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 15:05:46 +0000

pytorch-audio (0.7.2-1ubuntu1) jammy; urgency=medium

  * Build-depend on python3-dev instead of python3-all-dev

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 11 Feb 2022 12:40:44 +0000

pytorch-audio (0.7.2-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:24:57 +0000

pytorch-audio (0.7.2-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Oct 2021 08:28:13 +0000

pytorch-audio (0.7.2-1) unstable; urgency=medium

  * New upstream version 0.7.2

 -- Mo Zhou <lumin@debian.org>  Thu, 17 Dec 2020 12:42:03 +0800

pytorch-audio (0.7.0-1) unstable; urgency=medium

  * New upstream version 0.7.0
  * Change binary package architecture to any.
  * Specify X-Python3-Version: 3.9 in d/control.
  * Enable hardening.

 -- Mo Zhou <lumin@debian.org>  Wed, 25 Nov 2020 16:46:54 +0800

pytorch-audio (0.6.0-3) unstable; urgency=medium

  * Disable python 3.9 for pybuild.
  * Update maintainer mail address to debian-ai@l.d.o
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Oct 2020 15:51:37 +0800

pytorch-audio (0.6.0-2) experimental; urgency=medium

  * Require {libtorch-dev,python3-torch} (>= 1.6.0) as Build-Depends.
  * Rebuilt against libtorch1.6

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Sep 2020 10:59:39 +0800

pytorch-audio (0.6.0-1) experimental; urgency=medium

  * Initial release. (Closes: #958890)

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Aug 2020 12:07:41 +0800
