=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Spybuild --with python3

execute_after_dh_clean:
	-$(RM) -vf torchaudio/version.py

override_dh_auto_test:
	-dh_auto_test
