=== debian/changelog ===
pytorch-audio (0.13.1-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 0.12.1
  * cme update dpkg-copyright.
  * Require python3-torch (>= 1.12.0~).
  * Add autopkgtest file.

  [ Aron Xu ]
  * Team upload.
  * New upstream version 0.13.1 (Closes: #990627)
  * d/control: allow building with torch >= 1.13
  * d/control: update std-ver to 4.6.2, no changes
  * d/control: add cmake, pkg-config, ffmpeg to B-D
  * d/control: set X-Python3-Version to 3.11 (Closes: #1008922)
  * d/patches: add patch to address build system fixes
  * d/rules: disable ext-rename from dh-python and better cleanup

 -- Aron Xu <aron@debian.org>  Fri, 10 Feb 2023 03:05:28 +0800
