=== debian/control ===
--- 
+++ 
@@ -2,26 +2,33 @@
 Section: science
 Homepage: https://github.com/pytorch/audio
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-audio.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-audio
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
+Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: debhelper-compat (= 13),
+               cmake,
                dh-python,
+               libavdevice-dev,
+               libavcodec-dev,
+               libavfilter-dev,
+               libavformat-dev,
                libgflags-dev,
                libgoogle-glog-dev,
                libsox-dev,
-               libtorch-dev (>= 1.6.0),
+               libtorch-dev (>= 1.12.0~),
                ninja-build,
+               pkg-config,
                pybind11-dev,
-               python3-dev,
+               python3-all,
+               python3-all-dev,
                python3-parameterized <!nocheck>,
                python3-pytest <!nocheck>,
                python3-scipy <!nocheck>,
                python3-setuptools,
-               python3-torch (>= 1.6.0)
+               python3-torch (>= 1.12.0~),
+X-Python3-Version: 3.11
 
 Package: python3-torchaudio
 Architecture: any
