=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,14 @@
 
 execute_after_dh_clean:
 	-$(RM) -vf torchaudio/version.py
+	-$(RM) -r build/ torchaudio.egg-info/
+
+#execute_after_dh_install:
+	#find . -name *_torchaudio.so* -exec \
+	#	patchelf --replace-needed libtorchaudio.so lib/libtorchaudio.so {} \;
+
+override_dh_python3:
+	dh_python3 --no-ext-rename
 
 override_dh_auto_test:
 	-dh_auto_test
-
