=== debian/tests/control ===
Test-Command: cd /tmp; python3 -c "import sys, torch as th; print(sys.version, th.__path__, th.__version__)"
Depends: python3-torch
Restrictions: allow-stderr
Features: test-name=first_see_if_pytorch_is_functional

Test-Command: cd /tmp; python3 -c "import torchaudio as tha; print(tha.__path__, tha.__version__)"
Depends: python3-torch, @,
Restrictions: allow-stderr
Features: test-name=then_see_if_this_package_is_functional
